/******************************************************************************
  Copyright (c) 1992 Xerox Corporation.  All rights reserved.
  Portions of this code were written by Stephen White, aka ghond.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted.  Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws.  This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification.  Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    Pavel Curtis
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
    Pavel@Xerox.Com
 *****************************************************************************/

#ifndef Utils_h
#define Utils_h 1

#include "my-stdio.h"

#include "config.h"
#include "execute.h"

extern char cmap[];

extern int	mystrcasecmp(const char *, const char *);
extern int	mystrncasecmp(const char *, const char *, int);

extern int	verbcasecmp(const char *verb, const char *word);

extern void	object_match_failed(Objid, Objid, const char *);

enum error	become_number(Var, int *, char);
     
extern void	free_var(Var);
extern Var	var_dup(Var);
extern Var      var_ref(Var);

extern int	compare_ints(int a, int b);
extern int	equality(Var lhs, Var rhs, int case_matters);
extern int 	is_true(Var v);

extern void	init_pi(Parse_Info *);
extern void	free_pi(Parse_Info *, int);
extern Parse_Info *new_pi(void);
extern void	write_activ_as_pi(activation);
extern void	write_pi(Parse_Info *);
extern int	read_activ_as_pi(FILE *, activation *);
extern int	read_pi(FILE *, Parse_Info **);

Objid		create_object(const char *name, Objid parent, Objid owner);

extern char    *strsub(const char *, const char *, const char *, int);
extern int	strindex(const char *, const char *, int);
extern int	strrindex(const char *, const char *, int);

extern Var	get_system_property(const char *);
extern Objid	get_system_object(const char *);

void 		write_rt_env(const char **var_names, Var *rt_env,
			     unsigned size);
int		read_rt_env(FILE *f, const char ***old_names, Var **rt_env, 
			    int *old_size);
Var 	       *reorder_rt_env(Var *old_rt_env, const char **old_names, 
			       int old_size, Program *prog);

#endif

/* $Log: utils.h,v $
 * Revision 1.10  1992/10/23  23:03:47  pavel
 * Added copyright notice.
 *
 * Revision 1.9  1992/10/21  03:02:35  pavel
 * Converted to use new automatic configuration system.
 *
 * Revision 1.8  1992/10/17  20:57:30  pavel
 * Global rename of strdup->str_dup, strref->str_ref, vardup->var_dup, and
 * varref->var_ref.
 * Removed useless #ifdef of STRCASE.
 *
 * Revision 1.7  1992/09/08  21:55:12  pjames
 * Added `become_number()' (from bf_num.c).
 *
 * Revision 1.6  1992/09/03  16:23:16  pjames
 * Make cmap[] visible.
 *
 * Revision 1.5  1992/08/31  22:22:05  pjames
 * Changed some `char *'s to `const char *'
 *
 * Revision 1.4  1992/08/28  16:24:15  pjames
 * Added `varref()'.  Removed `copy_pi()'.
 *
 * Revision 1.3  1992/08/10  16:38:28  pjames
 * Added is_true (from execute.h) and *_activ_as_pi routines.
 *
 * Revision 1.2  1992/07/27  18:03:48  pjames
 * Changed name of ct_env to var_names
 *
 * Revision 1.1  1992/07/20  23:23:12  pavel
 * Initial RCS-controlled version.
 */
